unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ComCtrls, ExtCtrls, ImgList, jpeg, shellapi;

type
  TformMenuPrincipal = class(TForm)
    dlAbrir: TOpenDialog;
    PageControl1: TPageControl;
    tabMP3: TTabSheet;
    tabAcercaDe: TTabSheet;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    txtDisco: TEdit;
    txtArtista: TEdit;
    txtAno: TEdit;
    lsGenero: TComboBox;
    txtComentario: TEdit;
    txtPista: TSpinEdit;
    opVersionMP3: TRadioGroup;
    bAplicar: TButton;
    Button3: TButton;
    GroupBox2: TGroupBox;
    Panel1: TPanel;
    lsMP3: TListView;
    Button1: TButton;
    lForos: TLabel;
    Label14: TLabel;
    Shape1: TShape;
    Image1: TImage;
    txtInfo: TMemo;
    Label17: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label15: TLabel;
    Button2: TButton;
    tabErrores: TTabSheet;
    lsErrores: TListView;
    lNombreAplicacion: TLabel;
    lVersion: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure opVersionMP3Click(Sender: TObject);
    procedure bAplicarClick(Sender: TObject);
    procedure lForosClick(Sender: TObject);
    procedure LWEBClick(Sender: TObject);
    procedure Label7Click(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    listaGeneros : TStringList;
    lsFicheros : TList;
    procedure freeFilesItems;
  end;

var
  formMenuPrincipal: TformMenuPrincipal;

implementation

uses ID3;
{$R *.DFM}

procedure TformMenuPrincipal.FormCreate(Sender: TObject);
var
  i : integer;
  s : string;
begin
  lsFicheros := TList.Create;
  listaGeneros := TStringList.Create;
  try
    listaGeneros.LoadFromFile(ExtractFilePath(Application.ExeName) + 'generos.ini');
  except
    on EFOpenError do
    begin
      MessageDlg('Error al abrir el fichero de gneros musicales: generos.ini',
          mtError, [mbOK], 0);
      Application.Terminate;
      exit;
    end;
  end;

  i := 0;
  while (i < listaGeneros.Count) do begin
    s := trim(listaGeneros[i]);
    if (length(s) = 0) or (s[1] = ';') or (listaGeneros.Names[i] = '') then
      listaGeneros.Delete(i)
    else begin
      lsGenero.Items.Add(listaGeneros.Values[listaGeneros.Names[i]]);
      inc(i);
    end;
  end;
  tabMP3.Show;
  lNombreAplicacion.Caption := Application.Title;
  lVersion.Caption := 'Versin 2.2.2.254 (11-03-2008)';
end;

procedure TformMenuPrincipal.FormDestroy(Sender: TObject);
begin
  listaGeneros.Free;
  freeFilesItems;
  lsFicheros.Free;
end;

procedure TformMenuPrincipal.freeFilesItems;
var
  i : integer;
begin
  for i := 0 to lsFicheros.Count - 1 do
    ID3tag(lsFicheros[i]).Free;
  lsFicheros.Clear;
end;

procedure TformMenuPrincipal.Button1Click(Sender: TObject);
var
  i, j: integer;
  item: TListItem;
  id3: ID3tag;
begin
  if dlAbrir.Execute then
  begin
    lsMP3.Items.BeginUpdate;
    freeFilesItems;
    lsFicheros.Capacity := dlAbrir.Files.Count;
    for i := 0 to dlAbrir.Files.Count-1 do begin
      id3 := ID3tag.Create(dlAbrir.Files[i]);
      j := id3.ReadID3;
      if (j = ID3_OK) or (j = ID3_NO_TAG) then begin
        item := lsMP3.Items.Add;
        if (j = ID3_NO_TAG) then
          item.ImageIndex := -1;
        item.Caption := dlAbrir.Files[i];
        lsFicheros.Add(id3);
      end else
        id3.Free;
    end;
    lsMP3.Items.EndUpdate;
    bAplicar.Enabled := dlAbrir.Files.Count > 0;
    Button3.Enabled := bAplicar.Enabled;
  end;
end;

procedure TformMenuPrincipal.opVersionMP3Click(Sender: TObject);
begin
  if opVersionMP3.ItemIndex = 1 then
    txtPista.Enabled := true
  else
    txtPista.Enabled := false;
  if (opVersionMP3.ItemIndex = 1) then
  begin
    txtComentario.MaxLength := 28;
    if (length(txtComentario.Text) > 28) then
      txtComentario.Text := copy(txtComentario.Text, 1, 28);
  end
  else
    txtComentario.MaxLength := 30;
end;

procedure TformMenuPrincipal.bAplicarClick(Sender: TObject);
var
  i, j: integer;
  listaErrores : TStringList;
  s: string;
  item: TListItem;
  genero: byte;
begin
  if MessageDlg('Se van a modificar los ID3 de los ficheros MP3 seleccionados ' +
      'Desea continuar con el proceso?', mtConfirmation, [mbyes, mbno], 0) = mryes then
  begin
    listaErrores := TStringList.Create;
    genero := 255;
    if (lsGenero.ItemIndex <> -1) then
    begin
      s := lsGenero.Items[lsGenero.ItemIndex];
      for i := 0 to listaGeneros.Count - 1 do
        if (listaGeneros.Values[listaGeneros.Names[i]] = s) then
        begin
          try
            genero := StrToInt(listaGeneros.Names[i]);
          except
            on EConvertError do genero := 255;
          end;
          break;
        end;
    end;
    try
      for i := 0 to lsFicheros.Count - 1 do
      begin
        if (sender = bAplicar) then
        begin
          with ID3tag(lsFicheros[i]) do
          begin
            album := txtDisco.Text;
            artist := txtArtista.Text;
            year := txtAno.Text;
            comment := txtComentario.Text;
            comment := txtComentario.Text;
            genre := genero;
          end;
          j := ID3tag(lsFicheros[i]).SaveID3
        end
        else
          j := ID3tag(lsFicheros[i]).RemoveID3;
        if (j <> ID3_OK) then
        begin
          case j of
            ID3_OPEN_FILE : s := 'No se puede abrir el archivo';
            ID3_READ      : s := 'Lectura';
            ID3_WRITE     : s := 'Escritura';
            ID3_TOO_SMALL : s := 'Archivo demasiado pequeo';
          else
            s := 'Desconocido';
          end;
          listaErrores.Add(ID3tag(lsFicheros[i]).getFileName + '=' + s);
        end;
      end;
      if (listaErrores.Count > 0) then
      begin
        for i := 0 to listaErrores.Count - 1 do
        begin
          item := lsErrores.Items.Add;
          item.Caption := listaErrores.Names[i];
          item.SubItems.Add(listaErrores.Values[listaErrores.Names[i]]);
        end;
      end;
    finally
      listaErrores.Free;
    end;
  end;
end;

procedure TformMenuPrincipal.lForosClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com/modules.php?name=Foros&file=viewforum&f=9'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.LWEBClick(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.Label7Click(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com/modules.php?name=Foros&file=viewforum&f=9'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar('http://www.ajpdsoft.com'),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.Button2Click(Sender: TObject);
begin
  lsMP3.Clear;
end;

end.
